-- architecture body
architecture behavioral of lfsr4 is
   signal State_DP, State_DN : std_logic_vector(1 to 4);   
   -- for present and next state respectively
begin

   -- computation of next state using concatenation of bits
   State_DN <= (State_DP(3) xor State_DP(4)) & State_DP(1 to 3);

   -- updating of state
   process (Clk_CI,Rst_RBI)
   begin
      -- activities triggered by asynchronous reset
      if Rst_RBI='0' then
         State_DP <= "0001";
      -- activities triggered by rising edge of clock
      elsif Clk_CI'event and Clk_CI='1' then
         if Ena_SI='1' then 
            State_DP <= State_DN; -- admit next state into state register
         end if;
      end if;
   end process;

   -- updating of output
   Oup_DO <= State_DP(4);

end behavioral;
