// simulation model of a single-edge-triggered flip-flop with hardcoded timing 
module setff
  ( input logic Clk_CI, logic Rst_RBI, logic Dd_DI,
    output logic Qq_DO );

  logic State_DP; // state variable

  specify
     $setup ( Dd_DI, posedge Clk_CI, 1.09ns ); // data evt, clock evt, min. sep.
     $hold ( posedge Clk_CI, Dd_DI, 0.60ns );  // clock evt, data evt, min. sep.
  endspecify

  always_ff @(posedge Clk_CI, negedge Rst_RBI)
     if (~Rst_RBI)
        State_DP <= 1'b0;
     else
        State_DP <= Dd_DI;

  assign #0.92ns Qq_DO = State_DP;

endmodule
