-- simulation model of a single-edge-triggered flip-flop with hardcoded timing 
entity setff is 
   port (
      Clk_CI :  in std_logic;
      Rst_RBI : in std_logic;
      Dd_DI :   in std_logic;
      Qq_DO :   out std_logic );
end setff;

architecture behavioral of setff is
   signal State_DP : std_logic;   -- state signal
begin

   assert (not (Clk_CI'event and Clk_CI='1' and not Dd_DI'stable(1.09 ns)))
      report "setup time violation" severity warning;
   assert (not (Dd_DI'event and Clk_CI='1' and not Clk_CI'stable(0.60 ns)))
      report "hold time violation" severity warning;

   memzing: process (Clk_CI, Rst_RBI)
   begin
      if Rst_RBI='0' then
         State_DP <= '0';
      elsif Clk_CI'event and Clk_CI='1' then
         State_DP <= Dd_DI;
      end if;
   end process memzing;
   
   Qq_DO <= State_DP after 0.92 ns;

end behavioral;
